#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>

#define BUFFERSIZE0 0x10000
#define BUFFERSIZE 0x408


unsigned char open_request[] = {0x5a, 0x21, 0x09, 0x00,
				0x00, 0x00, 0x00, 0x00};
unsigned char open_ack[] = {0x5a, 0x20, 0x08, 0x00,
			    0x00, 0x00, 0x00, 0x00};
unsigned char close_request[] = {0x5a, 0x21, 0x0a, 0x00,
				0x00, 0x00, 0x00, 0x00};

unsigned char read_buffer[BUFFERSIZE];
unsigned char write_buffer[BUFFERSIZE] = {0x5a, 0x21, 0x00, 0x00,
					  0x00, 0x00, 0x00, 0x00};

unsigned char *buf;
unsigned pos, len;

int main(int argc, char *argv[])
{
	int ret, sock;
	struct sockaddr_un sa = {AF_UNIX, "/tmp/lj3100_2"};

	if (read_input())
		exit(3);

	sock = socket(PF_UNIX, SOCK_STREAM, 0);
	ret = connect(sock, &sa, sizeof(sa));
	if (ret == -1)
		perror("connect");

	write(sock, close_request, sizeof(open_request));
	write(sock, open_request, sizeof(open_request));

	ret = read(sock, read_buffer, BUFFERSIZE);
	if (ret == -1)
		perror("read");

	if (memcmp(read_buffer, open_ack, 6)) {
		fprintf(stderr, "missing ack\n");
		exit(1);
	}
	
	for (pos = 0; pos < len; pos += BUFFERSIZE - 8) {
		int len2 = len - pos;
		if (len2 > BUFFERSIZE - 8)
			len2 = BUFFERSIZE - 8;

		memcpy(write_buffer + 8, buf + pos, len2);
		write_buffer[4] = len2 & 0xff;
		write_buffer[5] = (len2 >> 8) & 0xff;
		ret = write(sock, write_buffer, len2 + 8);
		if (ret == -1) {
			perror("lj3100_print: write");
			exit(1);
		}
	}

	ret = write(sock, close_request, sizeof(close_request));
	if (ret == -1) {
		perror("lj3100_print: close");
		exit(1);
	}

	return 0;
}

int read_input()
{
	struct
	{
		unsigned short type;
		unsigned short size;
		unsigned short unknown;
	} header = {0, 0, 0};
	int ch;
	unsigned align = 0;

	buf = (unsigned char *) malloc(BUFFERSIZE0);
	len = 0;
	pos = 0;

	if (!buf)
		exit(2);


	while (1) {
		if (fread(&header, sizeof(header), 1, stdin) != 1)
			return -1;

		if (!memcmp(&header, "$$$$$$", 6))
			continue;

		if (header.size > BUFFERSIZE0) {
			fprintf(stderr, "lj3100_print: data block too large\n");
			return -1;
		}

		switch (header.type) {
		case 0:
			buf = (unsigned char *) realloc(buf, len + header.size);
			if (!buf)
				exit(2);

			if (fread(buf + pos, header.size, 1, stdin) != 1)
				return -2;

			pos += header.size;
			len += header.size;

			break;

		case 1:
			break;

		case 2:
			len = ((len + 0x3ff) / 0x400) * 0x400;
			memset(buf + pos, 0, len - pos);

			return 0;

		case 3:
		case 4:
		case 54:
			break;

		default:
			return -4;
		}
	}
}
